<template>
  <div ref="div">
    <canvas ref="canvas" :width="width" :height="height" id="graph" />
  </div>
</template>

<script>
import * as d3 from "d3";
import lasso from "@/util/lasso";

export default {
  props: {
    width: {
      type: Number,
      required: true
    },
    height: {
      type: Number,
      required: true
    },
    data: Object,
    dark: Boolean,
    selectedNodes: Array
  },

  data() {
    return {
      canvas: null,
      context: null,
      selection: null,
      transform: d3.zoomIdentity,
      color: d3.scaleOrdinal(d3.schemeCategory10),
      lassoInstance: null,
      root: null,
      layout: null,
      hierData: null,
      nodes: null,
      links: null,
      hoverNode: null
    };
  },

  watch: {
    dark: function() {
      this.tick();
    },
    width: function() {
      this.tick();
    },
    height: function() {
      this.tick();
    },
    data: function() {
      this.tick();
    },
    selectedNodes: function() {
      this.tick();
    }
  },

  computed: {
    lineWidth() {
      if (this.links.length < 10000) {
        return 1;
      } else if (this.links.length > 10000 && this.links.length < 50000) {
        return 1 / 200;
      } else {
        return 1 / 500;
      }
    },
    radius() {
      if (this.links.length < 10000) {
        return 5;
      } else {
        return 3;
      }
    }
  },

  methods: {
    tick() {
      this.context.save();

      // clear canvas
      this.context.clearRect(0, 0, this.canvas.width, this.canvas.height);
      this.context.translate(this.transform.x, this.transform.y);
      this.context.scale(this.transform.k, this.transform.k);

      this.context.strokeStyle = this.dark ? "white" : "grey";
      this.context.lineWidth = this.lineWidth;

      this.context.beginPath();
      this.links.forEach(l => {
        if (l.source.data.name !== "graph" && l.target.data.name !== "graph") {
          this.context.moveTo(l.source.x, l.source.y);
          this.context.lineTo(l.target.x, l.target.y);
        }
      });
      this.context.stroke();

      this.nodes.forEach(d => {
        if (d.data.name != "graph") {
          if (this.selectedNodes.includes(d.data.name) || this.hoverNode == d) {
            this.context.fillStyle = "red";
          } else {
            this.context.fillStyle = this.color(d.group);
          }
          this.context.beginPath();
          this.context.moveTo(d.x, d.y);
          this.context.arc(d.x, d.y, this.radius, 0, 2 * Math.PI);
          this.context.fill();
        }
      });
      if (this.hoverNode != null) {
        try {
          this.context.beginPath();
          let rectHeight = 10;
          let rectWidth = this.hoverNode.data.id.length * 3;
          this.context.fillStyle = this.dark ? "white" : "black";
          this.context.rect(
            this.hoverNode.x - rectWidth / 2,
            this.hoverNode.y - 20,
            rectWidth,
            rectHeight
          );
          this.context.fill();
          this.context.beginPath();
          this.context.font = "5px Georgia";
          this.context.textAlign = "center";
          this.context.textBaseline = "middle";

          this.context.fillStyle = this.dark ? "black" : "white";
          this.context.fillText(
            this.hoverNode.data.id.replace(/_/g, " "),
            this.hoverNode.x,
            this.hoverNode.y - 20 + rectHeight / 2
          );
        } catch (exception) {
          // hovernode does not have an id
        }
      }

      this.context.restore();
    },
    mouseMoved() {
      if (this.getVisibleNodes().length < 50) {
        let mouseX = this.transform.invertX(d3.event.layerX);
        let mouseY = this.transform.invertY(d3.event.layerY);
        this.hoverNode = null;
        this.nodes.forEach(d => {
          if (
            mouseX >= d.x - this.radius &&
            mouseX <= d.x + this.radius &&
            mouseY >= d.y - this.radius &&
            mouseY <= d.y + this.radius
          ) {
            this.hoverNode = d;
          }
        });
        this.tick();
      } else {
        this.hoverNode = null;
      }
    },
    getVisibleNodes() {
      const { transform } = this;

      return this.nodes.filter(
        node =>
          node.x > transform.invertX(0) &&
          node.x < transform.invertX(0 + this.canvas.width) &&
          node.y > transform.invertY(0) &&
          node.y < transform.invertY(0 + this.canvas.height)
      );
    },
    zoomed() {
      this.transform = d3.event.transform;
      this.tick();
    },
    handleLassoStart() {
      this.tick();
    },
    handleLassoEnd(lassoPolygon) {
      const { transform } = this;
      lassoPolygon.forEach(function(item) {
        item[0] = transform.invertX(item[0]);
        item[1] = transform.invertY(item[1]);
      });
      this.$store.commit(
        "setSelectedNodes",
        this.nodes
          .filter(function(d) {
            return d3.polygonContains(lassoPolygon, [d.x, d.y]);
          })
          .map(obj => {
            return obj.data.name;
          })
      );
      this.tick();
    }
  },

  async mounted() {
    this.canvas = this.$refs["canvas"];
    d3.select(this.canvas).on("click", () => {
      let mouseX = this.transform.invertX(d3.event.layerX);
      let mouseY = this.transform.invertY(d3.event.layerY);
        this.nodes.forEach(d => {
          if (
            mouseX >= d.x - this.radius &&
            mouseX <= d.x + this.radius &&
            mouseY >= d.y - this.radius &&
            mouseY <= d.y + this.radius
          ) {
            this.$store.commit("addSelectedNode", d.data.name);
          }
        });
    });
    this.context = this.canvas.getContext("2d");

    this.selection = d3
      .select(this.canvas)
      .on("mousemove", this.mouseMoved)
      .call(d3.drag().subject())
      .call(
        d3
          .zoom()
          .scaleExtent([1 / 10, 8])
          .on("zoom", this.zoomed)
      );

    this.lassoInstance = await lasso("#0bb", false);
    this.lassoInstance
      .on("start", this.handleLassoStart)
      .on("end", this.handleLassoEnd);

    // create key listeners for selection option
    let scope = this;
    window.addEventListener("keydown", e => {
      if (e.keyCode == 16) {
        try {
          d3.select(scope.$refs["div"])
            .append("svg")
            .style("position", "absolute")
            .style("top", 0)
            .style("left", 0)
            .attr("width", scope.canvas.width)
            .attr("height", scope.canvas.height);
          d3.select(scope.$refs["div"])
            .select("svg")
            .call(scope.lassoInstance);
        } catch (exception) {
          // wait until element is loaded
        }
      }
    });

    window.addEventListener("keyup", e => {
      if (e.keyCode == 16) {
        d3.select(scope.$refs["div"])
          .selectAll("svg")
          .remove();
      }
    });

    var rootData = this.data.hierarchy;

    this.root = d3.hierarchy(rootData);
    this.root.sum(function(d) {
      return d.value;
    });

    this.layout = d3.cluster();
    this.layout.size([this.canvas.width * 6, this.canvas.height * 6]);

    this.hierData = this.layout(this.root);

    this.nodes = this.hierData.descendants();
    this.links = this.hierData.links();

    this.tick();
  },

  destroyed() {
    this.selection = null;
    this.transform = null;
    this.color = null;
  }
};
</script>
